package org.dasein.cloud.jclouds.rackspace;

import java.util.ArrayList;
import java.util.Collection;
import java.util.Collections;
import java.util.Locale;

import org.dasein.cloud.CloudException;
import org.dasein.cloud.InternalException;
import org.dasein.cloud.OperationNotSupportedException;
import org.dasein.cloud.services.address.AddressServices;
import org.dasein.cloud.services.address.AddressType;
import org.dasein.cloud.services.address.IpAddress;
import org.dasein.cloud.services.address.IpForwardingRule;
import org.dasein.cloud.services.firewall.Protocol;

public class RackspaceAddress implements AddressServices {
    @SuppressWarnings("unused")
    private RackspaceCloud provider = null;
    
    RackspaceAddress(RackspaceCloud provider) {
        this.provider = provider;
    }

	public void assign(String addressId, String serverId) throws InternalException, CloudException {
		throw new OperationNotSupportedException();
	}

	public IpAddress getIpAddress(String addressId) throws InternalException, CloudException {
	    return null;
	}

	public String getProviderTermForIpAddress(Locale locale) {
		return "address";
	}

    @Override
    public Iterable<IpAddress> listPrivateIpPool(boolean unassignedOnly) throws InternalException, CloudException {
        return Collections.emptyList();
    }
    
    @Override
    public Iterable<IpAddress> listPublicIpPool(boolean unassignedOnly) throws InternalException, CloudException {
        return Collections.emptyList();
    }
    
    @Override
    public Collection<IpForwardingRule> listRules(String addressId) throws InternalException, CloudException {
        return new ArrayList<IpForwardingRule>();
    }

    @Override
    public String forward(String arg0, int arg1, Protocol arg2, int arg3, String arg4) throws InternalException, CloudException {
        throw new OperationNotSupportedException();
    }

    @Override
    public boolean isAssigned(AddressType type) {
        return false;
    }

    @Override
    public boolean isForwarding() {
        return false;
    }

    @Override
    public boolean isRequestable(AddressType type) {
        return false;
    }
    
    @Override
    public boolean isSubscribed() throws CloudException, InternalException {
        return true;
    }
    
    @Override
    public void releaseFromPool(String addressId) throws InternalException, CloudException {
        throw new OperationNotSupportedException();
    }

    @Override
    public void releaseFromServer(String addressId) throws InternalException, CloudException {
        throw new OperationNotSupportedException();
    }

    @Override
    public String request(AddressType type) throws InternalException, CloudException {
        throw new OperationNotSupportedException();
    }
    
    @Override
    public void stopForward(String ruleId) throws InternalException, CloudException {
        throw new OperationNotSupportedException();
    }
}
