package org.dasein.cloud.jclouds.rackspace;

import java.util.ArrayList;
import java.util.Collection;
import java.util.Locale;

import org.dasein.cloud.CloudException;
import org.dasein.cloud.CloudProvider;
import org.dasein.cloud.InternalException;
import org.dasein.cloud.services.dc.DataCenter;
import org.dasein.cloud.services.dc.DataCenterServices;
import org.dasein.cloud.services.dc.Region;

public class RackspaceDataCenter implements DataCenterServices {

    public RackspaceDataCenter(RackspaceCloud provider) { }
    
    public DataCenter getDataCenter(String dataCenterId) throws InternalException, CloudException {
        if( dataCenterId.equals("1") ) {
            DataCenter dataCenter = new DataCenter();
            
            dataCenter.setActive(true);
            dataCenter.setAvailable(true);
            dataCenter.setName("Standard");
            dataCenter.setProviderDataCenterId("1");
            dataCenter.setRegionId("main");
            return dataCenter;
        }
        return null;
    }

    public String getProviderTermForDataCenter(Locale locale) {
        return "data center";
    }

    public String getProviderTermForRegion(Locale locale) {
        return "region";
    }

    public Region getRegion(String regionId) throws InternalException, CloudException {
        if( regionId.equals("main") ) {
            Region region = new Region();
            
            region.setName("Main");
            region.setProviderRegionId(regionId);
            region.setAvailable(true);
            region.setActive(true);
            return region;
        }
        return null;
    }

    public Collection<DataCenter> listDataCenters(String regionId) throws InternalException, CloudException {
        ArrayList<DataCenter> dataCenters = new ArrayList<DataCenter>();
        
        dataCenters.add(getDataCenter("1"));
        return dataCenters;
    }

    public Collection<Region> listRegions() throws InternalException, CloudException {
        ArrayList<Region> regions = new ArrayList<Region>();
        
        regions.add(getRegion("main"));
        return regions;
    }

    public String matchDataCenter(CloudProvider provider, String dataCenterId) throws InternalException, CloudException {
        return dataCenterId;
    }

}
