package org.dasein.cloud.jclouds.rackspace;

import java.util.ArrayList;
import java.util.Collection;
import java.util.Locale;

import org.dasein.cloud.CloudException;
import org.dasein.cloud.InternalException;
import org.dasein.cloud.services.accounting.AccountingServices;
import org.dasein.cloud.services.accounting.DataFeeType;
import org.dasein.cloud.services.accounting.Offering;
import org.dasein.cloud.services.accounting.Prepayment;
import org.dasein.cloud.services.server.Platform;

public class RackspacePricing implements AccountingServices {

    @Override
    public double getDataFee(DataFeeType type, long amountInBytes) throws InternalException, CloudException {
        return 0.0;
    }

    @Override
    public double getMinimumMonthlyFee() throws InternalException, CloudException {
        return 0.0;
    }

    @Override
    public Offering getOffering(String offeringId) throws InternalException, CloudException {
        return null;
    }

    @Override
    public Prepayment getPrepayment(String prepaymentId) throws InternalException, CloudException {
        return null;
    }

    @Override
    public String getProviderTermForOffering(Locale locale) {
        return "product";
    }

    @Override
    public String getProviderTermForPrepayment(Locale locale) {
        return "prepayment";
    }

    @Override
    public double getUsageFee(Platform platform, String sizeId, String software) throws InternalException, CloudException {
        switch( platform ) {
            case WINDOWS:
                if( sizeId.equals("2") ) {
                    return 0.04;
                }
                else if( sizeId.equals("3") ) {
                    return 0.08;
                }
                else if( sizeId.equals("4") ) {
                    return 0.16;
                }
                else if( sizeId.equals("5") ) {
                    return 0.32;
                }
                else if( sizeId.equals("6") ) {
                    return 0.58;
                }
                else if( sizeId.equals("7") ) {
                    return 1.08;
                }
                else {
                    return 0.0;
                }
            case RHEL:
                return (getUsageFee(Platform.UNIX, sizeId, null) + 0.03);
            default:
                if( sizeId.equals("1") ) {
                    return 0.015;
                }
                else if( sizeId.equals("2") ) {
                    return 0.03;
                }
                else if( sizeId.equals("3") ) {
                    return 0.06;
                }
                else if( sizeId.equals("4") ) {
                    return 0.12;
                }
                else if( sizeId.equals("5") ) {
                    return 0.24;
                }
                else if( sizeId.equals("6") ) {
                    return 0.48;
                }
                else if( sizeId.equals("7") ) {
                    return 0.96;
                }
                else {
                    return 0.0;
                }
        }
    }

    @Override
    public Collection<Offering> listOfferings() throws InternalException, CloudException {
        return null;
    }

    @Override
    public Collection<Prepayment> listPrepayments() throws InternalException, CloudException {
        return new ArrayList<Prepayment>();
    }

    @Override
    public String prepay(String offeringId, int count) throws InternalException, CloudException {
        throw new UnsupportedOperationException("The Rackspace Cloud does not support prepayments.");
    }
}
